/*
 * Licensed under a Creative Commons Attribution 2.5 Slovenia License
 * http://creativecommons.org/licenses/by/2.5/si/
 * 2009 TineL Studio
 */

package net.tinelstudio.gis.model;

import java.util.List;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;

import net.tinelstudio.gis.model.domain.Address;
import net.tinelstudio.gis.model.domain.Street;

import org.hibernate.Session;
import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.springframework.orm.hibernate3.HibernateTemplate;

/**
 * @author TineL
 */
public class StudentExample {

  public class Student {
    private Long id;
    private String name;

    public Long getId() {
      return this.id;
    }

    public void setId(Long id) {
      this.id=id;
    }

    public String getName() {
      return this.name;
    }

    public void setName(String name) {
      this.name=name;
    }
  }

  @SuppressWarnings({"unused", "unchecked", "null"})
  public void example1() {
    Session session=null;

    List<Student> students=session.createQuery("from Student where name=?")
      .setString(1, "Janez").list();
  }

  @SuppressWarnings("unused")
  public class StudentEntity {

    @Entity
    public class Student {
      @Id
      @GeneratedValue(strategy=GenerationType.IDENTITY)
      private Long id;

      @Column
      private String name;

      // ...
    }
  }

  @SuppressWarnings({"unused", "unchecked"})
  public void example2() {
    Session session=null;

    List<Student> students=getHibernateTemplate().find(
      "from Student where name=?", "Janez");
  }

  private HibernateTemplate getHibernateTemplate() {
    return null;
  }

  @SuppressWarnings("unused")
  @Column
  @ManyToMany
  @Cascade(value=CascadeType.SAVE_UPDATE)
  private Set<Address> addresses;

  @SuppressWarnings("unused")
  @Column
  @ManyToMany
  @Cascade(value=CascadeType.SAVE_UPDATE)
  private Set<Street> streets;
}
